!   input.f90      LINUX version
       Subroutine Input
!
       USE repsblock
       USE mapblock
       USE fractblock
       USE specblock
       USE dstrb_blk
       implicit none
!  gans - answer: "output map?"
!  ians - answer: "input habitat optima?"
!  fract_ans - answer: "wrap fractal map?"

       integer i
       character*1 ians, fract_ans, lans, mort_switch
       character*9 dates
       character*60 filename
!
       call date_and_time (dates)
       print 100, dates
       write (15,100) dates
100    format (/t10,'Competition Model',t60,a9/)
!
       call map_in
!
       print 300
300    format (t10,'Enter the number of replications ')
       read *, nrep
       print 301, nrep
       write (15,331) nrep
301    format (t10,i10)
331    format (t10,'Replications = ',i10)
!
92     print 302
302    format (t10,'Enter the number of years per simulation ')
       read *, simlen
       if (simlen .lt. 1.0) goto 92
       print 303, simlen
       write (15,333) simlen
303    format (t10,i10)
333    format (t10,'Simulation years = ',i10)
!
       call spec_in

       call disturb_in

4001   print 400
400    format (t10,'Initialize species distributions: '/ &
        & t12,'<A>bundance, <O>ptimum, <R>andom, <E>nd Random Edge'/&
        & t12,'<L>ine, or <H>alf  ')
       read (*,212) mapinit
          select case (mapinit)
              case ('A','a')   ! off-map abundance
                write (15, 444)
444             format (t10,'Initial species distributions: off-map abundance')
              case ('O','o')
                write (15,431)
431             format (t10,'Initial species distribution: optimum')
              case ('R','r')
                mapinit = 'R'
                write (15,432)
432             format (t10,'Species distribution: random')
              case ('E','e')
                mapinit = 'E'
                write (15,433)
433             format (t10,'Species distribution: edge')
              case ('H','h')
                mapinit = 'H'
                write (15,434)
434             format (t10,'Species distribution: half')
              case ('L','l')
                mapinit = 'L'
                write (15,435)
435             format (t10,'Species randomly distributed on edge' )
              case default
                GOTO 4001
          end select
          print 401, mapinit

!  boundaries -- wrapped, reflecting, or absorbing
4002   PRINT 507
507    format (t10,'<W>rapped, <R>eflecting or <A>sorbing boundaries? ')
       read (*,212) movtype
          if (movtype .eq. 'w') movtype = 'W'
          if (movtype .eq. 'r') movtype = 'R'
          if (movtype .eq. 'a') movtype = 'A'
          if (movtype .eq. 'W') write (15,231)
          if (movtype .eq. 'R') write (15,232)
          if (movtype .eq. 'A') write (15,233)
231       format (t30,'Boundaries are wrapped')
232       format (t30,'Boundaries are reflecting')
233       format (t30,'Boundaries are absorbing')
!
       if (movtype .ne. 'A' .and. movtype .ne. 'R' .and. &
          movtype .ne. 'W') GOTO 4002
       PRINT 401, movtype
!
       print 405
405    format (t10,'Input mortality adjustment <y,n> ')
       read 103, mort_switch
103    format (a1)
       if (mort_switch .eq. 'y') mort_switch = 'Y'
       print 104, mort_switch
       write (15,104) mort_switch
104    format (t10,'Mortality adjustment? ',t50,a1)
!  set perx(i)   set perx(i)  set perx(i)
       do i = 1, ispecies
          select case (life_form(i))
             case ('B','b')
                life_form(i) = 'B'
                perx(i) = 0.5
             case ('P','p')
                life_form(i) = 'P'
                perx(i) = 0.1
             case ('L','l')
                life_form(i) = 'L'
                perx(i) = 0.01
             case default
                life_form(i) = 'A'
                perx(i) = 1.0
          end select
!  adjust perx if switch is set
          if (fract_per_yr < perx(i) .and. mort_switch .eq. 'Y') then
                perx(i) = perx(i) - fract_per_yr
          endif
          print 404, i, perx(i)
          write (15,404) i, perx(i)
404       format (t12,'Species ',i3,' mortality = ',g12.6)
       enddo

!  distance immigration
       print 701
701    format (t10,'Input alpha and distance parm (0.0-1.0) ')
       read *, alpha, Distance
       if (alpha .lt. 0.0) alpha = 1.0
       if (Distance .gt. 1.0) Distance = 1.0
       if (Distance .lt. 0.0) Distance = 0.0
       print 702, alpha, Distance
       write (15,702) alpha, Distance
702    format (t10,'alpha (inverse abundance exponent) is: ',t55,f8.4 / &
               t10,'Distance immigration (fraction) is: ',t55,f8.4)

!  create an output map file
       print 504
504    format (t10,'Create an output map?  ')
       read (*,212) gans
212    format (a1)
       if (gans .eq. 'y' .or. gans .eq. 'Y') gans = 'Y'
       print 401, gans
401    format (t10,a1)
       outfile = ' '
       if (gans .eq. 'Y') then
          print 505
!          write (15,505)
505       format (t10,'Name of output map file?  ')
          read (*,106) outfile
106       format (a60)
          print 506, outfile
          write (15,506) outfile
506       format (t10,'Output species map in file: ',a40)
       endif
!
!  input name of file for writing species movement data
       print 600
600    format (t10,'Name of the file for species movement data? ')
       read 601, filename
601    format (a60)
       print 2200, filename
       write (15,2230) filename
2200   format (t10,a60)
2230   format (t10,'Species movement data in file: ',t55,a40)
       open (11, file=filename,status='unknown')

!  set extinction switch
       PRINT 2204
2204   format (t10,'Check for species extinctions <y,n>? ')
       read (5,103) exans
       PRINT 2205, exans
       write (15, 2205) exans
2205   format (t10,'Species extinction check = ',t55,a1)

!  open output map file
       if (outfile .ne. ' ') open (13, FILE= outfile, STATUS='unknown')
!
       return
       end

       subroutine Prog_Cntrl (pctl)
!
       USE repsblock
       USE specblock
       USE dstrb_blk

       CHARACTER*2 pctl
       INTEGER ispno, icpopt
       REAL value

       pctl = 'CP'
       do WHILE (pctl .eq. 'CP')
          PRINT 100
100       format (t10,'Input program control: go, cp or stop')
          read 101, pctl
101       format (a2)

          select case (pctl)
             case ('go')
               pctl = 'GO'
             case ('cp')
               pctl = 'CP'
             case ('st')
               pctl = 'ST'
             case default
          END select

          PRINT 102, pctl
          write (15,102) pctl
102       format (//t10,'Program control: ',a2)

          select case (pctl)
              case ('CP')
              PRINT 103
103           format (t10,'Options for changing species parameters: ' / &
                      t15,'    1.  fecundity' / &
                      t15,'    2.  mean dispersal' / &
                      t15,'    3.  seed rain threshold')
              PRINT 104
104           format (t10,'Enter species number, change option, and new value ')
              read *, ispno, icpopt, value

              select case (icpopt)
                  case (1)
                    fecund(ispno) = value
                    PRINT 105, ispno, value
                    write (15,105) ispno, value
105                 format (t10,'Species: ',i3,' Fecundity: ',g12.6)
                  case (2)
                    xbar(ispno) = value
                    if (rdst(ispno) .gt. xbar(ispno)) rdst(ispno) = xbar(ispno)
                    if (dc(ispno) .eq. 'N') rdst(ispno) = xbar(ispno)
                    sd(ispno) = 0.0
                    if (dc(ispno) .eq. 'N') sd(ispno) = (rdst(ispno) - xbar(ispno)) / 3.0
                    if (dc(ispno) .eq. 'E') sd(ispno) = rdst(ispno) / 3.0

                    PRINT 106, ispno, value
106                 FORMAT (t10,'Speices: ',i3,' Mean dispersal: ',g12.6)
                    write (15,106) ispno, value
                  case (3)
                    sd_rain(ispno) = value
                    PRINT *, '  Seed rain threshold changed '
                    PRINT 107, ispno, value
107                 format (t10,'Species: ',i3,' Seed rain: ',g12.6)
                    write (15,107) ispno, value
! 
                  case default
                    PRINT *, '  No changes made '
              end select

              case default
          end select
       END do
       return

       end subroutine

       Subroutine map_in
       USE repsblock
       USE mapblock
       USE fractblock
       USE specblock
       USE dstrb_blk
       implicit none
       integer i, iseed
       character*1 ians, fract_ans, lans, mort_switch
       real psum, tmp

98     print 102
102    format (t10,'Enter map type to be analyzed:'/       &
   15x,'<I>  Input existing map file'/                     &
   15x,'<R>  Generate a random map (with replacement)'/    &
   15x,'<S>  Generate a simple random map'/                &
!  15x,'<C>  Generate a curdled (hierarchical) map'/       &
   15x,'<M>  Generate a multifractal random map'/          &
   15x,'<G>  Generate a multifractal randm map with a gradient'/)
       read (*,103) maptype
103    format (a1)
       print 104, maptype
       write (15,104) maptype
104    format (t10,'Map choice: ',a1)
!
!   maptype is the print of map to be generated
!      maptype = s       simple random map
!      maptype = r       random map without replacement
!      maptype = m       multifractal map
!      maptype = g       multifractal map gradient
!      maptype = i       import data set
!
          if (maptype .eq. 's') maptype = 'S'
          if (maptype .eq. 'r') maptype = 'R'
          if (maptype .eq. 'm') maptype = 'M'
          if (maptype .eq. 'g') maptype = 'G'
          if (maptype .eq. 'i') maptype = 'I'
!
       if (maptype .eq. 'R'                                 &
          .or. maptype .eq. 'I' .or. maptype .eq. 'S'       &
          .or. maptype .eq. 'M' .or. maptype .eq. 'G') then
            goto 197
         else
            goto 98
       endif
197    continue
!
!..if map to be input then read 'mapfile'
       if (maptype .eq. 'I') then
          pr = 1.0
          print 105
105       format (t10,'Enter name of input map file')
          read (*,106) mapfile
106       format (a60)
          print 114, mapfile
          write (15,114) mapfile
114       format (t10,'Input map name: ',a60)
       endif
!
!..enter parameters for multifractal map
       if (maptype .eq. 'M' .or. maptype .eq. 'G') then
          sigma = 1.0
1901      print 2201
2201      format (t10,'Enter the number of levels and H ')
!         read *, maxlevel, H, sigma
          read *, maxlevel, H
          print 2202, maxlevel, H
          write (15,2202) maxlevel, H
2202      format (t10,'Maxlevel ',i5,2x,' H = ',g12.6)
          N = 2**maxlevel
          if (N .gt. maxprm) then
            print *,'  Number of levels is too large'
            goto 1901
          endif
          if (H .lt. 0.0 .or. H .gt. 1.0) GOTO 1901
          irow = N
          jcol = N
          print 101, irow, jcol
          write (15,101) irow, jcol
          print 1902
1902      format (t10,'Wrap map? ')
          read (*,103) fract_ans
          wrap = .false.
          if (fract_ans .eq. 'y' .or. fract_ans .eq. 'Y') wrap = .true.
          print 1911, fract_ans, wrap
          write (15,1931) wrap
1911      format (t10,a1,'  Wrap = ',l1)
1931      format (t10,'  Wrap = ',l1)
       endif
!
       if (maptype .eq. 'G') then
          print 1850
1850      format (t10,'Gradient fractal: Initialize four map corners ')
          read *, northeast
          print 1851, northeast
          write (15,1851) northeast
1851      format (5x,g12.6)
          read *, southeast
          print 1851, southeast
          write (15,1851) southeast
          read *, southwest
          print 1851, southwest
          write (15,1851) southwest
          read *, northwest
          print 1851, northwest
          write (15,1851) northwest
       endif
!
!..iseed is random number seed
       iseed = -112773941
       maxrow = maxprm
       maxcol = maxprm
!
       if (maptype .ne. 'M' .and. maptype .ne. 'G') then
99        print 192
192       format (t10,'Enter the number of map rows and columns ')
          read *, irow, jcol
          if (irow .gt. maxrow .or. jcol .gt. maxcol) goto 99
          print 101, irow, jcol
          write (15,101) irow, jcol
101       format(t10,'Rows x Columns = ',i6,' x ',i6)
       endif
!
!  input random number seed
       print 115
115    format (t10,'Enter a negative random number seed ')
       read *,  iseed
       print 116, iseed
       if (iseed .gt. 0) iseed = -iseed
       write (15,116) iseed
116    format (t10,'Random number seed: ',i10)
!  save separate seeds for map generation, disturbance and movement
       iseed_map = iseed
       iseed_dstb = iseed
       iseed_mov = iseed
!
!..set up multiple habitats
95     print 203
203    format (t10,'Enter the number of map classes ')
       read *, ihab
       if (ihab .lt. 0) goto 95
       print 204, ihab
       write (15,204) ihab
204    format (t10,'Map classes = ',i6)
! allocate p vector
       ALLOCATE (p(0:ihab))
!
!..obtain probabilities for the 'ihab' habitat types
       if (maptype .ne. 'I' .and. maptype .ne. 'C') then
          psum = 0.0
          do i = 0,ihab
199         print 215, i
215         format (t10,'Type in the ',i3,'th probability ')
            read *, tmp
            print *, tmp
            psum = psum + tmp
            p(i) = psum
            if (p(i) .lt. 0.0) goto 199
          enddo
          pr = 0.0
          do i = 0,ihab
            p(i) = p(i)/psum
            print 206, i, p(i)
            write (15,206) i, p(i)
206         format (15x,'p(',i2,') = ',f8.4)
          enddo
          pr = p(ihab) - p(0)
       endif

       return
       end

       subroutine spec_in
       USE repsblock
       USE mapblock
       USE fractblock
       USE specblock
       USE dstrb_blk
       implicit none 
       integer i, j
       character*1 ians, fract_ans, lans, mort_switch
       character*60 filename, specfile

97     print 129
129    format (t10,'Enter the number of species ')
       read *, ispecies
       if (ispecies .lt. 0 ) goto 97
       print 304, ihab, ispecies
       write (15,334) ihab, ispecies
304    format (t10, 2i10)
334    format (t10,'Habitats = ',i4,' Species no. = ',i4)
!
!   input species seed competition matrix
       PRINT 305
305    format (t10,'Read species parameters from input file? ')
       READ (*,103) ians
103    format (a1)
       if (ians .eq. 'y' .or. ians .eq. 'Y') then
          print *,'        Enter name of input file'
          read (*,601) specfile
601    format (a60)
          print *, specfile
          open (19, file=specfile,status='old')
          do i = 1, ispecies
             read (19,*) (iopt(i,j), j=1,ihab)
             life_form(0) = ' '
             read (19,*) life_form(i), dc(i)
                if (life_form(i) .eq. 'a') life_form(i) = 'A'
                if (life_form(i) .eq. 'b') life_form(i) = 'B'
                if (life_form(i) .eq. 'p') life_form(i) = 'P'
                if (life_form(i) .eq. 'l') life_form(i) = 'L'

                if (dc(i) .eq. 'n') dc(i) = 'N'
                if (dc(i) .eq. 'u') dc(i) = 'U'
                if (dc(i) .eq. 'e') dc(i) = 'E'
                if (dc(i) .eq. 'd') dc(i) = 'D'
                if (dc(i) .eq. 'c') dc(i) = 'C'
!  read mean, max dispersal, fecundity and seed rain threshold
            read (19,*) xbar(i), rdst(i), fecund(i), sd_rain(i), d_slop(i)
               if (dc(i) .eq. 'N') rdst(i) = xbar(i)
               sd(i) = 0.0
               if (dc(i) .eq. 'N') sd(i) = (rdst(i) - xbar(i)) / 3.0
               if (dc(i) .eq. 'E') sd(i) = rdst(i) / 3.0
          enddo
          close(19)

        else

          print 306, ihab
306       format (t10,'Enter for each species three rows of info: ' / &
               t12,'(1) habitat optima (i) for the',i3,' habitat types'/  &
               t12,'(2) life-form (a), disperse function (a)'    /&
               t12,'(3) mean (r), max dispersal (r), fecundity (r), ' /&
               t18,'seed rain (r), and disturbance threshold (r)' )
          life_form(0) = ' '
          do i = 1, ispecies
             print *, ' Species ',i
             read *, (iopt(i,j), j=1,ihab)
             print *, (iopt(i,j), j=1,ihab)
             read *, life_form(i), dc(i)
             print 361, life_form(i), dc(i)
361          format (t2,a1,t6,a1)
!  dispersal kernal
                if (dc(i) .eq. 'n') dc(i) = 'N'
                if (dc(i) .eq. 'u') dc(i) = 'U'
                if (dc(i) .eq. 'e') dc(i) = 'E'
                if (dc(i) .eq. 'd') dc(i) = 'D'
                if (dc(i) .eq. 'c') dc(i) = 'C'
!  read mean, max dispersal, fecundity and seed rain threshold
            read *, xbar(i), rdst(i), fecund(i), sd_rain(i), d_slop(i)
            print *, xbar(i), rdst(i), fecund(i), sd_rain(i), d_slop(i)
               if (dc(i) .eq. 'N') rdst(i) = xbar(i)
               sd(i) = 0.0
               if (dc(i) .eq. 'N') sd(i) = (rdst(i) - xbar(i)) / 3.0
               if (dc(i) .eq. 'E') sd(i) = rdst(i) / 3.0
         enddo
       end if
!
!  output results to screen and log file
          print 379
          write (15,379) 
379       format (t10,'Habitat Optima Matrix (ispecies x habitat)')
          do i = 1, ispecies
             print 378, (iopt(i,j),j=1,ihab)
             write (15,378) (iopt(i,j),j=1,ihab)
378          format (t10,12i4)
          enddo
          print 377
          write (15,377)
377       format (t2,'S# Fecund L_form, D_form, Xbar     SD ' &
                      '       Rdst      Seed_r    D_slop')
       do i = 1, ispecies
          print 376, i, fecund(i), life_form(i), dc(i), xbar(i), sd(i), &
             rdst(i), sd_rain(i),d_slop(i)
          write (15,376) i, fecund(i), life_form(i), dc(i), xbar(i), sd(i), &
             rdst(i), sd_rain(i),d_slop(i)
376       format (t2,i2, f8.4,4x,a1,5x,a1,5(2x,f8.4))
       enddo

       return
       end

       subroutine disturb_in
       USE repsblock
       USE mapblock
       USE fractblock
       USE specblock
       USE dstrb_blk
       implicit none
       character*1 mort_switch
       integer i

!  select disturbance type
       PRINT 315
315    FORMAT (t10,'Input disturbance type <F,S,R,W,B or N> ')
       read 103, freq_type
       print 103, freq_type
103    format (a1)
       select case (freq_type)
           case ('f')
              freq_type = 'F'
           case ('s')
              freq_type = 'S'
           case ('r')
              freq_type = 'R'
           case ('w')
              freq_type = 'W'
           case ('b')
              freq_type = 'B'
           case default
              freq_type = 'N'
       end select

       write (15,316) freq_type
316    format (/t10,'Disturbance frequency type is ',t55,a1) 
       if (freq_type .ne. 'N') then
          PRINT 416
416       format (t10,'Input maximum disturbance severity index ')
          read *, max_sevr
          PRINT 417, max_sevr
417       format (t10,'Maximum disturbance severity index = ',t55,i4)
          write (15,417) max_sevr
       endif

!  select fraction of map disturbed per year and proportion of years disturbed
       select case (freq_type)
          case ('F','S','R','W','B')
             PRINT 317
317          format (t10,'Input fraction of map to be disturbed per year ')
             READ *, fract_per_yr
             write (15,318) fract_per_yr
             print *, fract_per_yr
318          format (t10,'Fraction of map to be disturbed per year ',t55,f6.4)


!  estimate minimum disturbance per year
             PRINT 319
319          FORMAT (t10,'Input fraction of years to be disturbed ')
             READ *, fract_years
             if (fract_years .lt. fract_per_yr) fract_years = fract_per_yr
             print *, fract_years
             write (15,349) fract_years
349          format (t10,'Fraction of years to be disturbed ',t55,f6.4)
          case default
             ! do nothing
       END select

!  select disturbance duration and variability
       select case (freq_type)
          case ('F','S')
              PRINT 320
320           format (t10,'Input duration of disturbance: ')
              READ *, idur
              print *, idur
              write (15,341) idur
341           format (t10,'Duration of disturbance: ',t55,i4)
              PRINT 325
325           format (t10,'Input CV for disturbance variability: ')
              read *, dcv
              print *, dcv
              write (15,326) dcv
326           format (t10,'CV for disturbances: ',t55,f6.4)
          case ('W')
              PRINT 325
              read *, dcv
              print *, dcv
              write (15,326) dcv
          case ('B')
              PRINT 323
323           format (t10,'Input the value of dH: ')
              READ *, dH
              print *, dH
              write (15,324) dH
324           format (t10,'Value of dH: ',t55,f6.4)
              PRINT 325
              read *, dcv
              print *, dcv
              write (15,326) dcv

          case default
       END select

!  select spatial distribution of disturbance
       select case (freq_type)
          case ('F','S','R','W','B')
             print 339
339          format (t10,'Enter spatial distribution of disturbance <R,C>' )
             READ 103, d_type
             PRINT 351, d_type
             write (15,351) d_type
351          format (t10,'Disturbance distribution type: ',t55,a1)
          select case (d_type)
             case ('C','c')
96              PRINT 352
352             format (t10,'Enter probability of cluster growth <0.0--1.0> ')
                if (px .gt. 1.0 .or. px .lt. 0.0) GOTO 96
                READ *, px
                PRINT *, px
                write (15,353) px
353             format (t10,'Probability for cluster growth is ',t55,f6.4)
             case default
                PRINT 354
354             format (t10,'Distribution type set to <R>')
                d_type = 'R'
          end select

          case default
       end select
       return
       end
